--------------------------------------------------------------------------------

on should_quote_path(quote_char, quote_by_default, quote_modifier, keypressed)
	set modifierIsDown to (keypressed contains quote_modifier)
	return quote_char is not equal to "" and quote_char is not equal to " " and ¬
        ((quote_by_default is equal to "TRUE" and not modifierIsDown) or (quote_by_default is equal to "FALSE" and modifierIsDown))
end should_quote_path
--------------------------------------------------------------------------------

on parse_file_path(this_file)
	set default_delimiters to AppleScript's text item delimiters
	
	-- if given file is a folder then strip terminal ":" so as to return
	-- folder name as file name and true parent directory
	if last item of (this_file as string) = ":" then
		set AppleScript's text item delimiters to ""
		set this_file to (items 1 through -2 of (this_file as string)) as string
	end if
	
	set AppleScript's text item delimiters to ":"
	set this_parent_dir to (text items 1 through -2 of (this_file as string)) as string
	set this_name to (text item -1 of (this_file as string)) as string
	
	-- default or no extension is empty string
	set this_extension to ""
	if this_name contains "." then
		set this_extension to "."
		set AppleScript's text item delimiters to "."
		set this_extension to this_extension & the last text item of this_name
		set this_name to (text items 1 through -2 of this_name) as string
	end if
	
	set AppleScript's text item delimiters to default_delimiters
	
	return {this_parent_dir, this_name, this_extension}
end parse_file_path
--------------------------------------------------------------------------------

on display_result_dialog(result, titleStr, msg)
    -- result can be here:
    --      stop (or 0) Shows a stop icon
    --      note (or 1) Shows the application icon
    --      caution (or 2) Shows a warning icon, badged with the application icon

    -- use the system default apple script runner not Automator's, they are not the same one :/
    tell application "System Events"
        -- make sure the dialog is in the front
        activate
        
        if result is equal to 1 then
            display dialog msg buttons {"Ok"} default button 1 with title titleStr
        else
            display dialog msg buttons {"Ok"} default button 1 with title titleStr with icon result
        end if
    end tell
	return 0
end display_result_dialog
--------------------------------------------------------------------------------

on format_path_for_clipboard(copy_mode, separator, quote_char, quote_by_default, quote_modifier, keypressed, paths)
	set these_paths to ""
	try
		set should_quote to should_quote_path(quote_char, quote_by_default, quote_modifier, keypressed)
        
		repeat with i from 1 to the count of paths
			set this_item to item i of paths
			
			if copy_mode is equal to "COPY_MODE_NAME" then
				set parsed to parse_file_path(POSIX file this_item)
				set this_item to ((items 2 through 3) of parsed) as string
			else
				if copy_mode is equal to "COPY_MODE_DIR" then
					set parsed to parse_file_path(POSIX file this_item)
					set this_item to (the POSIX path of (item 1 of parsed))
				end if
			end if
            if should_quote then
                set this_item to quote_char & this_item & quote_char
            end if
			
			if i is 1 then
				set these_paths to this_item
			else
				set these_paths to these_paths & separator & this_item
			end if
		end repeat
	on error errorMessage number errorNumber
		return
	end try
	--display dialog these_paths
	return {these_paths}
end format_path_for_clipboard
--------------------------------------------------------------------------------

on select_finder_elements(argv)
    set theFiles to {}
    repeat with i from 1 to the count of argv
        set thisFile to item i of argv
        set posixFile to POSIX file thisFile
        copy posixFile to end of theFiles
    end repeat
    tell application "Finder"
        reveal theFiles
        activate
    end tell
end select_finder_elements
--------------------------------------------------------------------------------
